!!ARBfp1.0

ATTRIB iPos=fragment.texcoord[0];
ATTRIB istn0=fragment.texcoord[1];
ATTRIB istn1=fragment.texcoord[2];
ATTRIB istn2=fragment.texcoord[3];
ATTRIB iTexCoord=fragment.texcoord[4];

PARAM itModelview[]={state.matrix.modelview.invtrans};
PARAM modelview[]={state.matrix.modelview};

TEMP fragNorm,objNorm,eyeNorm,eyePos,nDotV,reflection;

OUTPUT oCol=result.color;

# normala z 2D textury
TEX fragNorm,iTexCoord,texture[0],2D;

# transformacia hodnot do intervalu [-1,1]
MAD fragNorm,fragNorm,{2.0,2.0,2.0,0.0},{-1.0,-1.0,-1.0,0.0};

# transformacia normaly do object-space
DP3 objNorm.x,istn0,fragNorm;
DP3 objNorm.y,istn1,fragNorm;
DP3 objNorm.z,istn2,fragNorm;

# transformacia normaly do eye-space
DP3 eyeNorm.x,itModelview[0],objNorm;
DP3 eyeNorm.y,itModelview[1],objNorm;
DP3 eyeNorm.z,itModelview[2],objNorm;

# transformacia polohy vrcholu do eye-space
DP4 eyePos.x,modelview[0],iPos;
DP4 eyePos.y,modelview[1],iPos;
DP4 eyePos.z,modelview[2],iPos;
DP4 eyePos.w,modelview[3],iPos;

# reflektovanie vektoru do eye-space pomocou normaly R=2(N.-V)N+V
DP3 nDotV,eyeNorm,-eyePos;
MUL reflection,nDotV,2.0;
MUL reflection,reflection,eyeNorm;
ADD reflection,reflection,eyePos;

# vyhladanie v environment mape
TEX oCol,reflection,texture[1],CUBE;

END