#ifndef _MTEXTURE_H_
#define _MTEXTURE_H_

#define MAP_TEX_NUM 100

// volitelne parametre textury
enum {
 T_DEFAULT=1<<0,
 T_CLAMP=1<<1,
 T_CLAMP_TO_EDGE=1<<2,
 T_TRILINEAR=1<<3,
 T_MIPMAP=1<<4
};

// trieda premennych a funkcii pre pracu s OpenGL texturami
class mTexture {
public:
 mTexture();          // konstruktor
 virtual ~mTexture(); // destruktor

 GLuint texture_count;   // pocet nahratych textur

 GLuint texture_id[100]; // identifikatory nahravanych textur
 GLuint cubemap_id;      // identifikator Cube Map textury

 int LoadTexture(GLuint id,char *myfile,GLuint mode);                 // nahratie textury
 int Load1DTexture(GLuint id,char *myfile,GLuint mode);               // nahratie 1D textury
 int LoadBumpTexture(GLuint id1,GLuint id2,char *myfile,GLuint mode); // nahratie bump textury
 int LoadCubeMapTexture(char *mf1,char *mf2,char *mf3,                // nahratie Cube Map textury
                        char *mf4,char *mf5,char *mf6,GLuint mode);
 void FreeTexture(GLuint id);                                         // zrusenie OpenGL textury

 GLuint crosshair_tex_id; // identifikator textury zameriavacieho kriza

 int LoadCrosshairTexture(char *myfile); // nahratie textury zameriavacieho kriza
 int DrawCrosshair(GLfloat w,GLfloat h); // vykreslenie zameriavacieho kriza
private:
 GLuint t_a,t_b; // pomocne premenne

 unsigned char *td; // pomocna premenna
 GLint ti;          // pomocna premenna
};

#endif
