#include "mTorus.h"

int i;
int ring;

// konstruktor *************************************************************
Torus::Torus(int precision):vertices((precision+1)*(precision+1)),indices(2*precision*precision*3)
{
 // vypocet vrcholov 1. kruhu
 for (i=0;i<precision+1;i++) {
  TORUS_SPACE::vector3 v1(1.5f,0.0f,0.0f);
  TORUS_SPACE::vector3 v2(4.0f,0.0f,0.0f);

  vertices[i].position=v1.Rotate(i*2*PI/precision,TORUS_SPACE::vector3(0.0f,0.0f,1.0f))+v2;

  vertices[i].s=0.0f;
  vertices[i].t=(float) i*2.0f/(float) precision;

  vertices[i].tangent=TORUS_SPACE::vector3(0.0f,0.0f,-1.0f);
  TORUS_SPACE::vector3 v3(0.0f,-1.0f,0.0f);
  vertices[i].binormal=v3.Rotate(i*2*PI/precision,TORUS_SPACE::vector3(0.0f,0.0f,1.0f));
  vertices[i].normal=vertices[i].binormal.CrossProduct(vertices[i].tangent);
 }

 // rotacia 1. kruhu cim ziskame cely objekt torusu
 for (ring=1;ring<precision+1;ring++) {
  for (i=0;i<precision+1;i++) {
   vertices[ring*(precision+1)+i].position=vertices[i].position.Rotate(ring*2*PI/precision,TORUS_SPACE::vector3(0.0f,1.0f,0.0f));

   vertices[ring*(precision+1)+i].s=8.0f*ring/precision;
   vertices[ring*(precision+1)+i].t=vertices[i].t;

   vertices[ring*(precision+1)+i].tangent=vertices[i].tangent.Rotate(ring*2*PI/precision,TORUS_SPACE::vector3(0.0f,1.0f,0.0f));
   vertices[ring*(precision+1)+i].binormal=vertices[i].binormal.Rotate(ring*2*PI/precision,TORUS_SPACE::vector3(0.0f,1.0f,0.0f));
   vertices[ring*(precision+1)+i].normal=vertices[i].normal.Rotate(ring*2*PI/precision,TORUS_SPACE::vector3(0.0f,1.0f,0.0f));
  }
 }

 // vypocet indexov do pola vrcholov
 for (ring=0;ring<precision;ring++) {
  for (i=0;i<precision;i++) {
   indices[((ring*precision+i)*2)*3+0]=ring*(precision+1)+i;
   indices[((ring*precision+i)*2)*3+1]=(ring+1)*(precision+1)+i;
   indices[((ring*precision+i)*2)*3+2]=ring*(precision+1)+i+1;
   indices[((ring*precision+i)*2+1)*3+0]=ring*(precision+1)+i+1;
   indices[((ring*precision+i)*2+1)*3+1]=(ring+1)*(precision+1)+i;
   indices[((ring*precision+i)*2+1)*3+2]=(ring+1)*(precision+1)+i+1;
  }
 }

 // vypocet prvkov pola tangentov, binormal a normal
 for (std::vector<TorusVertex>::size_type i=0;i<vertices.size();++i) {
  vertices[i].tbn[0].x=vertices[i].tangent.x;
  vertices[i].tbn[0].y=vertices[i].binormal.x;
  vertices[i].tbn[0].z=vertices[i].normal.x;

  vertices[i].tbn[1].x=vertices[i].tangent.y;
  vertices[i].tbn[1].y=vertices[i].binormal.y;
  vertices[i].tbn[1].z=vertices[i].normal.y;

  vertices[i].tbn[2].x=vertices[i].tangent.z;
  vertices[i].tbn[2].y=vertices[i].binormal.z;
  vertices[i].tbn[2].z=vertices[i].normal.z;
 }
}

// destruktor **************************************************************
Torus::~Torus()
{

}
